// initialize accordions
$( function() 
{
    let accordions = $( ".accordion" );
    
    for (var i = 0; i < accordions.length; i++)
    {
        // look for the autoExpand attribute in the tag. this is a URL fragment that's used to determine 
        // if that page's accordion should automatically expand
        var key = accordions[i].getAttribute("key");
        
        if (!key)
            key = "NO_AUTOEXPAND";
        
        $(accordions[i]).accordion({ 
            animate: 100, 
            active: autoExpand(key), 
            collapsible: true, 
            heightStyle: "content",
            header: "." + key,
            icons: { header: "ui-icon-plus", activeHeader: "ui-icon-minus" } }); 
    }
        
    // on some pages, breadcrumbs are not appropriate. test before generating.
    if (shouldGenerateBreadcrumbs())
    {
        // now set up the breadcrumbs in <div id='breadcrumbs'></div> for each page and put highlights
        document.getElementById("breadcrumbs").innerHTML = breadcrumbs();
    }

    // apply the highlight class used by the rest of the accordion
    var leafAnchor = getCurrentAnchor();
    leafAnchor.className += " ui-accordion-header-active";
} );


// this function makes breadcrumbs from the active accordions. 
function breadcrumbs()
{
    let active_accordions = $( ".ui-accordion-header-active" );
    let breadcrumbs = "";
    
    for (var i = 0; i < active_accordions.length; i++)
    {
        breadcrumbs += active_accordions[i].innerText.trim() + " > ";
    }
    
    // now get the leaf
    var leafAnchor = getCurrentAnchor();
    
    if (leafAnchor)
    {
        breadcrumbs += leafAnchor.innerText;
    }
    else
    {
        // if we fail, return nothing, as incomplete breadcrumbs will most likely look bad
        breadcrumbs = ""; 
    }
    
    return breadcrumbs;
    
}

// Gets the anchor tag from the sidebar which matches the current URL.
// Used for making breadcrumbs and for highlighting.
function getCurrentAnchor()
{
    var pos = location.href.search("build");
    
    if (pos == -1) return; // something unexpected. bail.
    
    var shortUrl = location.href.substring(pos);
    
    pos = shortUrl.search("#");
    
    if (pos != -1) // there is a # in the URL, cut it off
        shortUrl = shortUrl.substring(0, pos);
    
    var anchors = $( "#accordion_panel" ).find("a");
    
    for (var i = 0; i < anchors.length; i++)
    {
        pos = anchors[i].href.search("build");
        
        if (pos == -1) continue; // something unexpected. might be an external url. ignore.
        
        currentUrl = anchors[i].href.substring(pos);
        
        if (shortUrl == currentUrl)
        {
            return anchors[i];
        }
    }
    
    // some of the pages (such as the typedoc pages in HC) may not have an associated 
    // anchor in the sidebar and we need to account for those product-specific cases
    return findSubstituteLeafAnchor();
}

function toTitleCase(str) 
{
	str = str.toLowerCase().split(' ');
	for (var i = 0; i < str.length; i++) {
		str[i] = str[i].charAt(0).toUpperCase() + str[i].slice(1);
	}
	return str.join(' ');
};

